/*----------------------------------------------------------------------------
 HMG - Harbour Windows GUI library source code

 Copyright 2002-2010 Roberto Lopez <mail.box.hmg@gmail.com>
 http://sites.google.com/site/hmgweb/

 This program is free software; you can redistribute it and/or modify it under 
 the terms of the GNU General Public License as published by the Free Software 
 Foundation; either version 2 of the License, or (at your option) any later 
 version. 

 This program is distributed in the hope that it will be useful, but WITHOUT 
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with 
 this software; see the file COPYING. If not, write to the Free Software 
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or 
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text 
 contained in this release of HMG.

 The exception is that, if you link the HMG library with other 
 files to produce an executable, this does not by itself cause the resulting 
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the 
 HMG library code into it.

 Parts of this project are based upon:

	"Harbour GUI framework for Win32"
 	Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
 	Copyright 2001 Antonio Linares <alinares@fivetech.com>
	www - http://www.harbour-project.org

	"Harbour Project"
	Copyright 1999-2008, http://www.harbour-project.org/

	"WHAT32"
	Copyright 2002 AJ Wos <andrwos@aust1.net> 

	"HWGUI"
  	Copyright 2001-2008 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/



/* 
  The adaptation of the source code of this file to support Unicode was made 
  by Dr. Claudio Soto, November 2012. 
  mail: <srvet@adinet.com.uy>
  blog: http://srvet.blogspot.com
*/
#include "SET_COMPILE_HMG_UNICODE.ch"
#include "HMG_UNICODE.h"




#define WINVER  0x0500
#define _WIN32_IE      0x0500
#define HB_OS_WIN_32_USED
//#define _WIN32_WINNT   0x0400
#define _WIN32_WINNT 0x0500 // for AnimateWindow()

#define WM_TASKBAR     WM_USER+1043  // User define message

#include <shlobj.h>
#include <windows.h>
#include "richedit.h"
#include "hbapi.h"
#include "hbvm.h"
#include "hbstack.h"
#include "hbapiitm.h"
#include "winreg.h"
#include "tchar.h"
#include <commctrl.h>
#include <windowsx.h>

static void ChangeNotifyIcon (HWND hWnd, HICON hIcon, TCHAR * szText);
static void ShowNotifyIcon (HWND hWnd, BOOL bAdd, HICON hIcon, TCHAR * szText);


//-------------------------------------------------------------------------------------//
void HMG_GetWindowMessage (HWND, UINT, WPARAM, LPARAM, int, int);
BOOL HMG_ReadKey (HWND, UINT, WPARAM, LPARAM);
BOOL New_Behavior_WndProc = FALSE;
//-------------------------------------------------------------------------------------//


//-------------------------------------------------------------------------------------//
LRESULT CALLBACK WndProc (HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
//-------------------------------------------------------------------------------------//
{
   static PHB_DYNS pDynSym = NULL;
   long r;

   if ( pDynSym == NULL)
        pDynSym = hb_dynsymFindName ( "EVENTS" );

   hb_vmPushSymbol (hb_dynsymSymbol ( pDynSym ));
   hb_vmPushNil ();
   hb_vmPushLong (( LONG ) hWnd   );
   hb_vmPushLong (( LONG ) nMsg    );
   hb_vmPushLong (( LONG ) wParam );
   hb_vmPushLong (( LONG ) lParam );
   hb_vmDo ( 4 );

   r = hb_parnl ( -1 );

   if (New_Behavior_WndProc == FALSE)
   {  if (r == 0)
         return DefWindowProc (hWnd, nMsg, wParam, lParam);
      else
         return r;
   }
   else
   {  if (r == -1)
         return DefWindowProc (hWnd, nMsg, wParam, lParam);
      else
         return r;
   }
}


// Claudio Soto (June 2013)
//-------------------------------------------------------------------------------------//
HB_FUNC (SETNEWBEHAVIORWNDPROC)
//-------------------------------------------------------------------------------------//
{
   New_Behavior_WndProc = hb_parl(1);
}


// Claudio Soto (June 2013)
//-------------------------------------------------------------------------------------//
HB_FUNC (GETNEWBEHAVIORWNDPROC)
//-------------------------------------------------------------------------------------//
{
   hb_retl (New_Behavior_WndProc);
}


//-------------------------------------------------------------------------------------//
HB_FUNC ( DOMESSAGELOOP ) 
//-------------------------------------------------------------------------------------//
{  MSG Msg;

   while( GetMessage( &Msg, NULL, 0, 0) )
   {
     // Claudio Soto (June 2013)
     // HMG_GetWindowMessage (Msg.hwnd, Msg.message, Msg.wParam, Msg.lParam, (WH_MIN -1), -1);

      if(!IsWindow(GetActiveWindow()) || !IsDialogMessage(GetActiveWindow(),&Msg))
      {
         TranslateMessage( &Msg );
         DispatchMessage ( &Msg );
      }
   }
}


//-------------------------------------------------------------------------------------//
HB_FUNC( PROCESSMESSAGE )
//-------------------------------------------------------------------------------------//
{ 
  MSG Msg;
  if ( PeekMessage ( &Msg, NULL, 0, 0, PM_REMOVE ) )
  {
     // Claudio Soto (June 2013)
     // HMG_GetWindowMessage (Msg.hwnd, Msg.message, Msg.wParam, Msg.lParam, (WH_MIN -1), -1);

     TranslateMessage ( &Msg );
     DispatchMessage  ( &Msg );
     hb_retl (TRUE);
  }
  else
     hb_retl (FALSE);
}


HB_FUNC ( DOEVENTS )
{
   MSG Msg;
   while( PeekMessage ( &Msg, NULL, 0, 0, PM_REMOVE ) )
   {   
      // Claudio Soto (June 2013)
      // HMG_GetWindowMessage (Msg.hwnd, Msg.message, Msg.wParam, Msg.lParam, (WH_MIN -1), -1);

      TranslateMessage ( &Msg );
      DispatchMessage  ( &Msg );
   }
}



//****************************************************************************************************************************//


HB_FUNC ( INITWINDOW )
{
	HWND hwnd;
	int Style = WS_POPUP , ExStyle ;

	if ( hb_parl (16) )
	{
	        ExStyle = WS_EX_CONTEXTHELP ;
	}
	else
	{
		ExStyle = 0 ;
		if ( ! hb_parl (6) )
		{
			Style = Style | WS_MINIMIZEBOX ;
		}
		if ( ! hb_parl (7) )
		{
			Style = Style | WS_MAXIMIZEBOX ;
		}
	}

	if ( ! hb_parl (8) )
	{
		Style = Style | WS_SIZEBOX ;
	}

	if ( ! hb_parl (9) )
	{
		Style = Style | WS_SYSMENU ;
	}

	if ( ! hb_parl (10) )
	{
		Style = Style | WS_CAPTION ;
	}

	if ( hb_parl (11) )
	{
		ExStyle = ExStyle | WS_EX_TOPMOST ;
	}

	if ( hb_parl (14) )
	{
		Style = Style | WS_VSCROLL ;
	}

	if ( hb_parl (15) )
	{
		Style = Style | WS_HSCROLL ;
	}

	if ( hb_parl (17) ) // Panel
	{
	        Style = WS_CHILD ;
	        ExStyle = ExStyle | WS_EX_CONTROLPARENT | WS_EX_STATICEDGE ;
	}


	hwnd = CreateWindowEx( ExStyle , HMG_parc(12) , 
   HMG_parc(1), Style ,
	hb_parni(2),
	hb_parni(3),
	hb_parni(4),
	hb_parni(5),
	(HWND) hb_parnl (13),(HMENU)NULL, GetModuleHandle( NULL ) ,NULL);

	if(hwnd == NULL)
	{
	MessageBox(0, _TEXT("Window Creation Failed!"), _TEXT("Error!"),
	MB_ICONEXCLAMATION | MB_OK | MB_SYSTEMMODAL);
	return;
	}

	hb_retnl ((LONG)hwnd);
}

HB_FUNC ( INITMODALWINDOW )
{
	HWND parent ;
	HWND hwnd ;
	int Style ;
	int ExStyle = 0 ;

	if ( hb_parl (13) )
	{
	        ExStyle = WS_EX_CONTEXTHELP ;
	}

	if ( hb_parl (14) )
	{
	        ExStyle = WS_EX_TOOLWINDOW ;
	}

	parent = (HWND) hb_parnl (6);

	Style = WS_POPUP;

	if ( ! hb_parl (7) )
	{
		Style = Style | WS_SIZEBOX ;
	}

	if ( ! hb_parl (8) )
	{
		Style = Style | WS_SYSMENU ;
	}

	if ( ! hb_parl (9) )
	{
		Style = Style | WS_CAPTION ;
	}

	if ( hb_parl (11) )
	{
		Style = Style | WS_VSCROLL ;
	}

	if ( hb_parl (12) )
	{
		Style = Style | WS_HSCROLL ;
	}

	hwnd = CreateWindowEx( ExStyle , HMG_parc(10) , 
   HMG_parc(1) , Style,
	hb_parni(2),
	hb_parni(3),
	hb_parni(4),
	hb_parni(5),
	parent,(HMENU)NULL, GetModuleHandle( NULL ) ,NULL);

	if(hwnd == NULL)
	{
	MessageBox(0, _TEXT("Window Creation Failed!"), _TEXT("Error!"),
	MB_ICONEXCLAMATION | MB_OK | MB_SYSTEMMODAL);
	return;
	}

	hb_retnl ((LONG)hwnd);
}



HB_FUNC ( SHOWWINDOW )
{
   ShowWindow((HWND) hb_parnl (1), SW_SHOW);
}


HB_FUNC ( EXITPROCESS )
{
   UINT uExitCode = (UINT) hb_parnl (1);
   ExitProcess(uExitCode);
}


HB_FUNC ( INITSTATUS )
{
	HWND hwnd;
	HWND hs;
    TCHAR *Text = (TCHAR*) HMG_parc(2);

	hwnd = (HWND) hb_parnl (1);

	hs = CreateStatusWindow ( WS_CHILD | WS_BORDER | WS_VISIBLE, _TEXT("") , hwnd, hb_parni(3) );

	SendMessage(hs,SB_SIMPLE, TRUE , 0 );
	SendMessage(hs,SB_SETTEXT,255 , (LPARAM) Text  );
	hb_retnl ( (LONG) hs );

}

HB_FUNC ( SETSTATUS )
{
	HWND hwnd;
    TCHAR *Text = (TCHAR *) HMG_parc(2);

	hwnd = (HWND) hb_parnl (1);

	SendMessage(hwnd,SB_SIMPLE, TRUE , 0 );
	SendMessage(hwnd,SB_SETTEXT,255 , (LPARAM) Text);

}

HB_FUNC (MAXIMIZE)
{
	ShowWindow((HWND) hb_parnl( 1 ), SW_MAXIMIZE);
}

HB_FUNC (MINIMIZE)
{
	ShowWindow((HWND) hb_parnl( 1 ), SW_MINIMIZE);
}

HB_FUNC (RESTORE)
{
	ShowWindow( (HWND) hb_parnl( 1 ),SW_RESTORE);
}

HB_FUNC( GETACTIVEWINDOW )
{
   HWND hwnd = GetActiveWindow();
   hb_retnl ( (LONG) hwnd );
}

HB_FUNC( SETACTIVEWINDOW )
{
	HWND hwnd;
	hwnd = (HWND) hb_parnl (1);
	SetActiveWindow (hwnd);
}

HB_FUNC( POSTQUITMESSAGE )
{
	PostQuitMessage( hb_parnl( 1 ) );
}

HB_FUNC ( DESTROYWINDOW )
{
	DestroyWindow( (HWND) hb_parnl( 1 ) );
}

HB_FUNC (ISWINDOWENABLED)
{
	HWND hwnd;
	int r;

	hwnd = (HWND) hb_parnl (1);
	r = IsWindowEnabled( hwnd );	 
	if ( r != 0 )
	{
		hb_retl( TRUE );
	}
	else
	{
		hb_retl( FALSE );
	}
}

HB_FUNC (ENABLEWINDOW)
{
	HWND hwnd;
	hwnd = (HWND) hb_parnl (1);
	EnableWindow( hwnd , TRUE );	 
}

HB_FUNC (DISABLEWINDOW)
{
	HWND hwnd;
	hwnd = (HWND) hb_parnl (1);
	EnableWindow( hwnd , FALSE );	
}

HB_FUNC (SETFOREGROUNDWINDOW)
{
	HWND hwnd;
	hwnd = (HWND) hb_parnl (1);
	SetForegroundWindow( hwnd );	
}
HB_FUNC (BRINGWINDOWTOTOP)
{
	HWND hwnd;
	hwnd = (HWND) hb_parnl (1);
	BringWindowToTop( hwnd );	
}


HB_FUNC (GETFOREGROUNDWINDOW)
{
	HWND x;
	x = GetForegroundWindow() ;
	hb_retnl ((LONG) x );
}

HB_FUNC (GETNEXTWINDOW)
{
	HWND hwnd;
	HWND x;

	hwnd = (HWND) hb_parnl (1);

	x = GetWindow( hwnd, GW_HWNDNEXT );

	hb_retnl ((LONG) x );
}

HB_FUNC (GETPREVWINDOW)
{
	HWND hwnd;
	HWND x;

	hwnd = (HWND) hb_parnl (1);

	x = GetWindow( hwnd, GW_HWNDPREV );

	hb_retnl ((LONG) x );
}

HB_FUNC ( SETWINDOWTEXT )
{
   TCHAR *Text = (TCHAR *) HMG_parc(2);
   SetWindowText((HWND) hb_parnl (1), Text);
}

HB_FUNC (C_CENTER) 
{
	RECT rect;
	int w, h, x, y;
	GetWindowRect((HWND) hb_parnl (1), &rect);
	w  = rect.right  - rect.left;
	h = rect.bottom - rect.top;
	x = GetSystemMetrics(SM_CXSCREEN);
	y = GetSystemMetrics(SM_CYSCREEN);
	SetWindowPos((HWND) hb_parnl (1), HWND_TOP, (x - w) / 2,
	(y - h) / 2, 0, 0, SWP_NOSIZE | SWP_NOACTIVATE ) ;
}

HB_FUNC ( GETWINDOWTEXT )
{
   int iLen = GetWindowTextLength((HWND) hb_parnl (1));
   TCHAR *cText = (TCHAR*) hb_xgrab((iLen+1) * sizeof(TCHAR));
   GetWindowText((HWND) hb_parnl (1), (LPTSTR) cText, (iLen+1));
   HMG_retc( cText );
   hb_xfree( cText );
}


HB_FUNC ( SENDMESSAGE )
{
	hb_retnl( (LONG) SendMessage( (HWND) hb_parnl( 1 ), (UINT) hb_parnl( 2 ), (WPARAM) hb_parnl( 3 ), (LPARAM) hb_parnl( 4 ) ) );
}

HB_FUNC ( UPDATEWINDOW )
{
	hb_retnl( (LONG) UpdateWindow( (HWND) hb_parnl( 1 ) ) );
}

HB_FUNC ( GETNOTIFYCODE )
{
   hb_retnl( (LONG) (((NMHDR FAR *) hb_parnl(1))->code) );
}

HB_FUNC ( GETHWNDFROM )
{
   hb_retnl( (LONG) (((NMHDR FAR *) hb_parnl(1))->hwndFrom) );
}

HB_FUNC ( GETDRAWITEMHANDLE )
{
   hb_retnl( (LONG) (((DRAWITEMSTRUCT FAR *) hb_parnl(1))->hwndItem) );
}


HB_FUNC ( GETFOCUS )
{
   hb_retnl( (LONG) GetFocus() );
}

HB_FUNC ( GETGRIDCOLUMN )
{
	#define pnm ((NM_LISTVIEW *) hb_parnl(1) ) 
	hb_retnl ( (LPARAM) (pnm->iSubItem) ) ;
	#undef pnm 
}

HB_FUNC ( GETGRIDVKEY )
{
	#define pnm ((LV_KEYDOWN *) hb_parnl(1) ) 
	hb_retnl ( (LPARAM) (pnm->wVKey) ) ;
	#undef pnm 
}

HB_FUNC ( MOVEWINDOW )
{
   hb_retl( MoveWindow(
                       (HWND) hb_parnl(1),
                       hb_parni(2),
                       hb_parni(3),
                       hb_parni(4),
                       hb_parni(5),
                       (HB_ISNIL(6) ? TRUE : hb_parl(6))
                      ));
}

HB_FUNC ( GETWINDOWRECT )
{
  RECT rect;
  hb_retl( GetWindowRect((HWND) hb_parnl (1), &rect));
  hb_storvnl(rect.left,2,1);
  hb_storvnl(rect.top,2,2);
  hb_storvnl(rect.right,2,3);
  hb_storvnl(rect.bottom,2,4);
}

HB_FUNC ( REGISTERWINDOW )
{
	WNDCLASS WndClass;

	HBRUSH hbrush = 0 ;

	WndClass.style         = CS_HREDRAW | CS_VREDRAW | CS_OWNDC ;
	WndClass.lpfnWndProc   = WndProc;
	WndClass.cbClsExtra    = 0;
	WndClass.cbWndExtra    = 0;
	WndClass.hInstance     = GetModuleHandle( NULL );
	WndClass.hIcon         = LoadIcon(GetModuleHandle(NULL),  HMG_parc(1) );
	if (WndClass.hIcon==NULL)
	{
		WndClass.hIcon= (HICON) LoadImage( GetModuleHandle(NULL),  HMG_parc(1) , IMAGE_ICON, 0, 0, LR_LOADFROMFILE + LR_DEFAULTSIZE ) ;
	}
	if (WndClass.hIcon==NULL)
	{
		WndClass.hIcon= LoadIcon(NULL, IDI_APPLICATION);
	}
	WndClass.hCursor       = LoadCursor(NULL, IDC_ARROW);

	if ( hb_parvni(3, 1) == -1 )
	{
		WndClass.hbrBackground = (HBRUSH)( COLOR_BTNFACE + 1 );
	}
	else
	{
		hbrush = CreateSolidBrush( RGB(hb_parvni(3, 1), hb_parvni(3, 2), hb_parvni(3, 3)) );
		WndClass.hbrBackground = hbrush ;
	}

	WndClass.lpszMenuName  = NULL;
	WndClass.lpszClassName = HMG_parc(2);

	if(!RegisterClass(&WndClass))
	{
	MessageBox(0, _TEXT("Window Registration Failed!"), _TEXT("Error!"),
	MB_ICONEXCLAMATION | MB_OK | MB_SYSTEMMODAL);
	ExitProcess(0);
	}
	hb_retnl ( (LONG) hbrush ) ;
}

HB_FUNC ( UNREGISTERWINDOW )
{
	UnregisterClass ( HMG_parc(1), GetModuleHandle( NULL ) ) ;	
} 

HB_FUNC (GETDESKTOPWIDTH) 
{
	hb_retni ( GetSystemMetrics(SM_CXSCREEN) ) ;
}

HB_FUNC (GETVSCROLLBARWIDTH) 
{
	hb_retni ( GetSystemMetrics(SM_CXVSCROLL) ) ;
}

HB_FUNC (GETHSCROLLBARHEIGHT) 
{
	hb_retni ( GetSystemMetrics(SM_CYHSCROLL) ) ;
}

HB_FUNC (GETDESKTOPHEIGHT)
{
   hb_retni ( GetSystemMetrics(SM_CYSCREEN) ) ;
}

HB_FUNC (GETWINDOWROW) 
{
	RECT rect;
	int y ;
	GetWindowRect((HWND) hb_parnl (1), &rect) ;
	y = rect.top ;
	hb_retni(y);
}

HB_FUNC (GETWINDOWCOL) 
{
	RECT rect;
	int x ;
	GetWindowRect((HWND) hb_parnl (1), &rect) ;
	x = rect.left ;
	hb_retni(x);
}

HB_FUNC (GETWINDOWWIDTH) 
{
	RECT rect;
	int w ;
	GetWindowRect((HWND) hb_parnl (1), &rect) ;
	w = rect.right - rect.left ;
	hb_retni(w);
}

HB_FUNC (GETWINDOWHEIGHT) 
{
	RECT rect;
	int h ;
	GetWindowRect((HWND) hb_parnl (1), &rect) ;
	h = rect.bottom - rect.top ;
	hb_retni(h);
}

HB_FUNC (GETTITLEHEIGHT) 
{
	hb_retni ( GetSystemMetrics( SM_CYCAPTION ) ) ;	
} 

HB_FUNC (GETBORDERHEIGHT) 
{
	hb_retni ( GetSystemMetrics(  SM_CYSIZEFRAME ) ) ;	
} 

HB_FUNC (GETBORDERWIDTH) 
{
	hb_retni ( GetSystemMetrics( SM_CXSIZEFRAME ) ) ;	
} 

HB_FUNC (GETMENUBARHEIGHT) 
{
	hb_retni ( GetSystemMetrics( SM_CYMENU ) ) ;	
} 

HB_FUNC (GETSYSTEMMETRICS) 
{
	hb_retni ( GetSystemMetrics( hb_parni(1) ) ) ;	
} 


HB_FUNC ( ISWINDOWVISIBLE )
{
   hb_retl( IsWindowVisible( (HWND) hb_parnl( 1 ) ) ) ;
}

//----------------------------------------------------------------------------//
HB_FUNC ( SHOWNOTIFYICON )
{  
   TCHAR * Text = (TCHAR *) HMG_parc(4);
   ShowNotifyIcon( (HWND) hb_parnl(1), (BOOL) hb_parl(2), (HICON) hb_parnl(3), Text );
}
//----------------------------------------------------------------------------//

static void ShowNotifyIcon(HWND hWnd, BOOL bAdd, HICON hIcon, TCHAR *szText)
{
  NOTIFYICONDATA nid;
  ZeroMemory(&nid,sizeof(nid));
  nid.cbSize=sizeof(NOTIFYICONDATA);
  nid.hWnd=hWnd;
  nid.uID=0;
  nid.uFlags=NIF_ICON | NIF_MESSAGE | NIF_TIP;
  nid.uCallbackMessage=WM_TASKBAR;
  nid.hIcon=hIcon;
  lstrcpy(nid.szTip,szText);

  if(bAdd)
    Shell_NotifyIcon(NIM_ADD,&nid);
  else
    Shell_NotifyIcon(NIM_DELETE,&nid);
}

HB_FUNC ( GETINSTANCE )
{
   hb_retnl( ( LONG ) GetModuleHandle( NULL ) );
}

HB_FUNC ( GETCURSORPOS )
{
   POINT pt;
   GetCursorPos( &pt );

   if (HB_ISBYREF(1))
       hb_stornl ((LONG) pt.x, 1);
   if (HB_ISBYREF(2))
       hb_stornl ((LONG) pt.y, 2);

   hb_reta( 2 );
   hb_storvni( pt.y, -1, 1 );
   hb_storvni( pt.x, -1, 2 );
}

HB_FUNC (LOADTRAYICON)
{
	HICON himage;
	HINSTANCE hInstance  = (HINSTANCE) hb_parnl(1);  // handle to application instance
	TCHAR *IconName =  (TCHAR*)  HMG_parc(2);   // name string or resource identifier

   himage = LoadIcon( hInstance ,  IconName );
	if (himage==NULL)
	{
		himage = (HICON) LoadImage( hInstance ,  IconName , IMAGE_ICON, 0, 0, LR_LOADFROMFILE + LR_DEFAULTSIZE ) ;
	}
	hb_retnl ( (LONG) himage );
}

HB_FUNC ( CHANGENOTIFYICON )
{
   TCHAR * Text = (TCHAR *) HMG_parc(3);
   ChangeNotifyIcon( (HWND) hb_parnl(1), (HICON) hb_parnl(2), Text);
}

static void ChangeNotifyIcon(HWND hWnd, HICON hIcon, TCHAR *szText)
{
  NOTIFYICONDATA nid;
  ZeroMemory(&nid,sizeof(nid));
  nid.cbSize=sizeof(NOTIFYICONDATA);
  nid.hWnd=hWnd;
  nid.uID=0;
  nid.uFlags=NIF_ICON | NIF_MESSAGE | NIF_TIP;
  nid.uCallbackMessage=WM_TASKBAR;
  nid.hIcon=hIcon;
  lstrcpy(nid.szTip,szText);

  Shell_NotifyIcon(NIM_MODIFY,&nid);
}

HB_FUNC ( INITSPLITBOX )
{
	HWND hwndOwner = (HWND) hb_parnl ( 1 ) ;
	REBARINFO     rbi;
	HWND   hwndRB;
	INITCOMMONCONTROLSEX icex;

	int Style = 	WS_CHILD | 
			WS_VISIBLE | 
			WS_CLIPSIBLINGS | 
			WS_CLIPCHILDREN | 
			RBS_BANDBORDERS | 
			RBS_VARHEIGHT | 
			RBS_FIXEDORDER ;


	if ( hb_parl (2) )
	{
		Style = Style | CCS_BOTTOM ;
	}

	if ( hb_parl (3) )
	{
		Style = Style  | CCS_VERT ;
	}

	icex.dwSize = sizeof(INITCOMMONCONTROLSEX);
	icex.dwICC   = ICC_COOL_CLASSES|ICC_BAR_CLASSES;
	InitCommonControlsEx(&icex);

	hwndRB = CreateWindowEx( WS_EX_TOOLWINDOW | WS_EX_DLGMODALFRAME , REBARCLASSNAME /*_TEXT("ReBarWindow32")*/,
                           TEXT(""), Style ,
                           0,0,0,0,
                           hwndOwner,
                           NULL,
                           GetModuleHandle(NULL),
                           NULL);

	// Initialize and send the REBARINFO structure.
	rbi.cbSize = sizeof(REBARINFO);  // Required when using this struct.
	rbi.fMask  = 0;
	rbi.himl   = (HIMAGELIST)NULL;
	SendMessage(hwndRB, RB_SETBARINFO, 0, (LPARAM)&rbi) ;

	hb_retnl ( (LONG) hwndRB );

}

HB_FUNC ( INITSPLITCHILDWINDOW )
{
	HWND hwnd;
	int Style;

	Style = WS_POPUP ;

	if ( !hb_parl(4) )
	{
		Style = Style | WS_CAPTION ;
	}

	if ( hb_parl (7) )
	{
		Style = Style | WS_VSCROLL ;
	}

	if ( hb_parl (8) )
	{
		Style = Style | WS_HSCROLL ;
	}

	hwnd = CreateWindowEx( WS_EX_STATICEDGE | WS_EX_TOOLWINDOW , HMG_parc(3) , 
   HMG_parc(5), Style,
	0,
	0,
	hb_parni(1),
	hb_parni(2),
	0,(HMENU)NULL, GetModuleHandle( NULL ) ,NULL);

	if(hwnd == NULL)
	{
	MessageBox(0, _TEXT("Window Creation Failed!"), _TEXT("Error!"),
	MB_ICONEXCLAMATION | MB_OK | MB_SYSTEMMODAL);
	return;
	}

	hb_retnl ((LONG)hwnd);
}

HB_FUNC (SIZEREBAR) 
{
	SendMessage(  (HWND) hb_parnl (1)  , RB_SHOWBAND , (WPARAM)(INT) 0 , (LPARAM)(BOOL) 0 );
	SendMessage(  (HWND) hb_parnl (1)  , RB_SHOWBAND , (WPARAM)(INT) 0 , (LPARAM)(BOOL) 1 );
}

HB_FUNC ( GETITEMPOS )
{
   hb_retnl( (LONG) (((NMMOUSE FAR *) hb_parnl(1))->dwItemSpec) );
}


HB_FUNC( SETSCROLLRANGE )
{
   hb_retl( SetScrollRange( (HWND) hb_parnl( 1 ),
                            hb_parni( 2 )       ,
                            hb_parni( 3 )       ,
                            hb_parni( 4 )       ,
                            hb_parl( 5 )        
                          ) ) ;
}

HB_FUNC( GETSCROLLPOS )
{
   hb_retni( GetScrollPos( (HWND) hb_parnl( 1 ), hb_parni( 2 ) ) ) ;
}

HB_FUNC( GETWINDOWSTATE )
{
	WINDOWPLACEMENT wp ;
	wp.length = sizeof(WINDOWPLACEMENT) ;
	GetWindowPlacement( (HWND) hb_parnl( 1 ) , &wp );
	hb_retni ( wp.showCmd ) ;
}

HB_FUNC ( REDRAWWINDOW )
{
   RedrawWindow ( (HWND) hb_parnl( 1 ), NULL , NULL , RDW_ERASE | RDW_FRAME | RDW_INVALIDATE | RDW_ALLCHILDREN | RDW_ERASENOW | RDW_UPDATENOW );
}

HB_FUNC ( REDRAWWINDOWCONTROLRECT )
{
   RECT r;
   r.top    = hb_parni(2) ;
   r.left   = hb_parni(3) ;
   r.bottom = hb_parni(4) ;
   r.right  = hb_parni(5) ;

   RedrawWindow ( (HWND) hb_parnl( 1 ), &r , NULL, RDW_ERASE  | RDW_FRAME | RDW_INVALIDATE | RDW_ALLCHILDREN | RDW_ERASENOW | RDW_UPDATENOW );
}

HB_FUNC ( ADDSPLITBOXITEM )
{
	REBARBANDINFO rbBand;
	RECT          rc;
    TCHAR * Text;
    
	int Style = RBBS_CHILDEDGE | RBBS_GRIPPERALWAYS ;

	if ( hb_parl (4) )           
	{
		Style = Style | RBBS_BREAK ;
	}

	GetWindowRect ( (HWND) hb_parnl ( 1 ) , &rc ) ;

	rbBand.cbSize = sizeof(REBARBANDINFO); 
	rbBand.fMask  = RBBIM_TEXT | RBBIM_STYLE | RBBIM_CHILD | RBBIM_CHILDSIZE | RBBIM_SIZE ;
	rbBand.fStyle = Style ;
	rbBand.hbmBack= 0;   

    Text = (TCHAR *) HMG_parc(5);
	rbBand.lpText     = Text;
	rbBand.hwndChild  = (HWND)hb_parnl( 1 );


	if ( !hb_parl (8) )           
	{
		// Not Horizontal
		rbBand.cxMinChild = hb_parni(6) ? hb_parni(6) : 0 ;       //0 ; JP 61 
		rbBand.cyMinChild = hb_parni(7) ? hb_parni(7) : rc.bottom - rc.top ; // JP 61
		rbBand.cx         = hb_parni(3) ;
	}
	else
	{
		// Horizontal
		if ( hb_parni(6) == 0 && hb_parni(7) == 0 )
		{
			// Not ToolBar
			rbBand.cxMinChild = 0 ;   
			rbBand.cyMinChild = rc.right - rc.left ; 
			rbBand.cx         = rc.bottom - rc.top ;
		}
		else
		{
			// ToolBar
			rbBand.cxMinChild = hb_parni(7) ? hb_parni(7) : rc.bottom - rc.top ; // JP 61 
			rbBand.cyMinChild = hb_parni(6) ? hb_parni(6) : 0 ; 
			rbBand.cx         = hb_parni(7) ? hb_parni(7) : rc.bottom - rc.top ;

		}
	}

	SendMessage( (HWND) hb_parnl( 2 ) , RB_INSERTBAND , (WPARAM)-1 , (LPARAM) &rbBand ) ;

}

HB_FUNC (C_SETWINDOWRGN)
{
   HRGN hrgn;
   if ( hb_parni(6)==0)
          SetWindowRgn(GetActiveWindow(),NULL,TRUE);
   else
     {
     if ( hb_parni(6)==1 )
        hrgn=CreateRectRgn(hb_parni(2),hb_parni(3),hb_parni(4),hb_parni(5));
     else
        hrgn=CreateEllipticRgn(hb_parni(2),hb_parni(3),hb_parni(4),hb_parni(5));
     SetWindowRgn(GetActiveWindow(),hrgn,TRUE);
     // Should be hb_parnl(1) instead of GetActiveWindow()
     }
}

HB_FUNC (C_SETPOLYWINDOWRGN)
{
 HRGN hrgn;
 POINT lppt[512];
 int i,fnPolyFillMode;
 int cPoints = hb_parinfa(2,0);

 if(hb_parni(4)==1)
         fnPolyFillMode=WINDING;
 else
         fnPolyFillMode=ALTERNATE;

 for(i = 0; i <= cPoints-1; i++)
  {
   lppt[i].x=hb_parvni(2,i+1);
   lppt[i].y=hb_parvni(3,i+1);
  }
  hrgn=CreatePolygonRgn(lppt,cPoints,fnPolyFillMode);
  SetWindowRgn(GetActiveWindow(),hrgn,TRUE);
}

HB_FUNC ( GETHELPDATA )
{
   hb_retnl( (LONG) (((HELPINFO FAR *) hb_parnl(1))->hItemHandle) );
}

HB_FUNC ( GETMSKTEXTMESSAGE )
{
   hb_retnl( (LONG) (((MSGFILTER FAR *) hb_parnl(1))->msg) );
}

HB_FUNC ( GETMSKTEXTWPARAM )
{
   hb_retnl( (LONG) (((MSGFILTER FAR *) hb_parnl(1))->wParam) );
}

HB_FUNC ( GETMSKTEXTLPARAM )
{
   hb_retnl( (LONG) (((MSGFILTER FAR *) hb_parnl(1))->lParam) );
}


/*
HB_FUNC (GETWINDOW)
{
   hb_retnl( ( LONG ) GetWindow( ( HWND ) hb_parnl( 1 ), hb_parni( 2 ) ) );
}
*/


HB_FUNC ( GETGRIDOLDSTATE )
{
	#define pnm ((NM_LISTVIEW *) hb_parnl(1) ) 
	hb_retnl ( (LPARAM) (pnm->uOldState) ) ;
	#undef pnm 
}

HB_FUNC ( GETGRIDNEWSTATE )
{
	#define pnm ((NM_LISTVIEW *) hb_parnl(1) ) 
	hb_retnl ( (LPARAM) (pnm->uNewState) ) ;
	#undef pnm 
}


HB_FUNC ( GETGRIDDISPINFOINDEX )
{
	LV_DISPINFO* pDispInfo = (LV_DISPINFO*)hb_parnl(1);

	int iItem = pDispInfo->item.iItem;
	int iSubItem = pDispInfo->item.iSubItem;

	hb_reta( 2 );
	hb_storvni( iItem + 1 , -1, 1 ); 
	hb_storvni( iSubItem + 1 , -1, 2 ); 

}

HB_FUNC ( SETGRIDQUERYDATA )
{
   LV_DISPINFO* pDispInfo = (LV_DISPINFO*)hb_parnl(1);
   pDispInfo->item.pszText = (TCHAR*) HMG_parc(2);    
}

HB_FUNC ( SETGRIDQUERYIMAGE )
{
	LV_DISPINFO* pDispInfo = (LV_DISPINFO*)hb_parnl(1) ;
	pDispInfo->item.iImage = hb_parni( 2 ) ;
}

HB_FUNC ( GETESCAPESTATE )
{
	 hb_retni ( GetKeyState( VK_ESCAPE ) ) ;
}

HB_FUNC ( GETALTSTATE )
{
	 hb_retni ( GetKeyState( VK_MENU ) ) ;
}

HB_FUNC ( GETCURSORROW )
{
   POINT pt;
   GetCursorPos( &pt );
   hb_retni( pt.y );
}

HB_FUNC ( GETCURSORCOL )
{
   POINT pt;
   GetCursorPos( &pt );
   hb_retni( pt.x );
}


HB_FUNC ( ISINSERTACTIVE )
{
	 hb_retl ( GetKeyState( VK_INSERT ) ) ;
}

HB_FUNC ( ISCAPSLOCKACTIVE )
{
	 hb_retl ( GetKeyState( VK_CAPITAL ) ) ;
}

HB_FUNC ( ISNUMLOCKACTIVE )
{
	 hb_retl ( GetKeyState( VK_NUMLOCK ) ) ;
}

HB_FUNC ( ISSCROLLLOCKACTIVE )
{
	 hb_retl ( GetKeyState( VK_SCROLL ) ) ;
}

HB_FUNC( FINDWINDOWEX )
{
   hb_retnl( (LONG) FindWindowEx( (HWND) hb_parnl( 1 ) ,
                                  (HWND) hb_parnl( 2 ) ,
                                  HMG_parc( 3 ),
                                  HMG_parc( 4 )
                                ) ) ;
}

HB_FUNC( INITDUMMY )
{
	CreateWindowEx( 0L , WC_STATIC /*_TEXT("Static")*/ , 
   _TEXT("") , WS_CHILD ,
	0, 0 , 0, 0,
	(HWND) hb_parnl (1),(HMENU)NULL , GetModuleHandle(NULL) , NULL ) ;

}

HB_FUNC ( REGISTERSPLITCHILDWINDOW )
{
	WNDCLASS WndClass;

	HBRUSH hbrush = 0 ;

	WndClass.style         = CS_OWNDC ;
	WndClass.lpfnWndProc   = WndProc;
	WndClass.cbClsExtra    = 0;
	WndClass.cbWndExtra    = 0;
	WndClass.hInstance     = GetModuleHandle( NULL );
	WndClass.hIcon         = LoadIcon(GetModuleHandle(NULL),  HMG_parc(1) );
	if (WndClass.hIcon==NULL)
	{
		WndClass.hIcon= (HICON) LoadImage( GetModuleHandle(NULL),  HMG_parc(1) , IMAGE_ICON, 0, 0, LR_LOADFROMFILE + LR_DEFAULTSIZE ) ;
	}
	if (WndClass.hIcon==NULL)
	{
		WndClass.hIcon= LoadIcon(NULL, IDI_APPLICATION);
	}
	WndClass.hCursor       = LoadCursor(NULL, IDC_ARROW);

	if ( hb_parvni(3, 1) == -1 )
	{
		WndClass.hbrBackground = (HBRUSH)( COLOR_BTNFACE + 1 );
	}
	else
	{
		hbrush = CreateSolidBrush( RGB(hb_parvni(3, 1), hb_parvni(3, 2), hb_parvni(3, 3)) );
		WndClass.hbrBackground = hbrush ;
	}

	WndClass.lpszMenuName  = NULL;
	WndClass.lpszClassName = HMG_parc(2);

	if(!RegisterClass(&WndClass))
	{
	MessageBox(0, _TEXT("Window Registration Failed!"), _TEXT("Error!"),
	MB_ICONEXCLAMATION | MB_OK | MB_SYSTEMMODAL);
	ExitProcess(0);
	}
	hb_retnl ( (LONG) hbrush ) ;
}

HB_FUNC ( SETWINDOWCURSOR )
{
	HCURSOR ch;

	if( HB_ISCHAR(2) )
	{
		ch = LoadCursor( GetModuleHandle( NULL ), HMG_parc( 2 ) ) ;

		if ( ch == NULL )
		{
			ch = LoadCursorFromFile ( HMG_parc( 2 ) ) ;
		}
	}
	else
	{
		ch = LoadCursor( NULL, MAKEINTRESOURCE( hb_parnl( 2 ) ) ) ;
	}

	SetClassLong( (HWND) hb_parnl(1) ,    // window handle 
		GCL_HCURSOR,      // change cursor 
		(LONG) ch );   // new cursor 

}

LRESULT APIENTRY HyperLinkSubClassFunc ( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam );

static WNDPROC HyperLinklpfnOldWndProc;

HB_FUNC( INITHYPERLINKCURSOR )
{
	HWND hwnd;
	hwnd = (HWND) hb_parnl (1);
	HyperLinklpfnOldWndProc = (WNDPROC) SetWindowLong ( (HWND) hwnd , GWL_WNDPROC, (LONG) HyperLinkSubClassFunc);
}

LRESULT APIENTRY HyperLinkSubClassFunc( HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam )
{
	if ( nMsg == WM_MOUSEMOVE )
	{	
		SetCursor( LoadCursor( GetModuleHandle( NULL ) , _TEXT("HMG_FINGER") ) ) ;
		return CallWindowProc(HyperLinklpfnOldWndProc, hWnd, 0 , 0, 0 ) ;
	}
	else
	{
		return CallWindowProc(HyperLinklpfnOldWndProc, hWnd, nMsg , wParam, lParam ) ;
	}

}

HB_FUNC ( GETDS )   // call if CellNavigation == .F.
{
   LPARAM lParam = hb_parnl(1) ;
   LPNMLVCUSTOMDRAW lplvcd = (LPNMLVCUSTOMDRAW) lParam;

   if (lplvcd->nmcd.dwDrawStage == CDDS_PREPAINT ) 
       hb_retni ( CDRF_NOTIFYITEMDRAW ) ;
   else if (lplvcd->nmcd.dwDrawStage == CDDS_ITEMPREPAINT )
        hb_retni ( CDRF_NOTIFYSUBITEMDRAW ) ;
   else if (lplvcd->nmcd.dwDrawStage == (CDDS_SUBITEM | CDDS_ITEMPREPAINT ))
        hb_retni ( -1 ) ;
   else
        hb_retni ( CDRF_DODEFAULT ) ;
}


HB_FUNC ( GETDSX )   // call if CellNavigation == .T.
{
   LPARAM lParam = hb_parnl(1) ;

   LPNMLVCUSTOMDRAW lplvcd = (LPNMLVCUSTOMDRAW) lParam;

   if (lplvcd->nmcd.dwDrawStage == CDDS_PREPAINT ) 
       hb_retni ( CDRF_NOTIFYITEMDRAW ) ;

   else if (lplvcd->nmcd.dwDrawStage == CDDS_ITEMPREPAINT )
   {
        if (ListView_GetNextItem ( (HWND) hb_parnl(2), - 1 ,LVNI_ALL | LVNI_SELECTED) == hb_parni(3) - 1 )
            ListView_SetItemState( (HWND) hb_parnl(2), hb_parni(3) -1 , 0, LVIS_SELECTED );

        hb_retni ( CDRF_NOTIFYSUBITEMDRAW ) ;
   }
   else if (lplvcd->nmcd.dwDrawStage == (CDDS_SUBITEM | CDDS_ITEMPREPAINT))
        hb_retni ( -1 ) ;
   else
      hb_retni ( CDRF_DODEFAULT ) ;
}



HB_FUNC ( GETRC )   // call if GETDS or GETDSX return -1 
{
   LPARAM lParam = hb_parnl(1);
   LPNMLVCUSTOMDRAW lplvcd = (LPNMLVCUSTOMDRAW) lParam;

   hb_reta( 2 );
   // nRow draw
   hb_storvnl( (LONG) lplvcd->nmcd.dwItemSpec + 1 , -1, 1 );   // The item number. What is contained in this member will depend on the type of control 
                                                               // that is sending the notification. See the NM_CUSTOMDRAW notification reference for 
                                                               // the specific control to determine what, if anything, is contained in this member.
   // nCol draw                                                            
   hb_storvni( (INT) lplvcd->iSubItem + 1 , -1, 2 );   // Index of the subitem that is being drawn. 
                                                       // If the main item is being drawn, this member will be zero.
}


HB_FUNC ( SETBCFC )   // Set DynamicBackColor and Set DynamicForeColor
{
	LPARAM	lParam	= hb_parnl(1) ;

	LPNMLVCUSTOMDRAW lplvcd = (LPNMLVCUSTOMDRAW)lParam;

	lplvcd->clrText   = hb_parni(3);
	lplvcd->clrTextBk = hb_parni(2) ;
	hb_retni ( CDRF_NEWFONT ) ;

}


HB_FUNC ( SETBCFC_DEFAULT )   // Set DefaultDynamicBackColor and  Set DefaultDynamicForeColor
{
	LPARAM	lParam	= hb_parnl(1) ;

	LPNMLVCUSTOMDRAW lplvcd = (LPNMLVCUSTOMDRAW)lParam;

	lplvcd->clrText   = RGB(0,0,0);         // BLACK
	lplvcd->clrTextBk = RGB(255,255,255);   // WHITE
	hb_retni ( CDRF_NEWFONT ) ;

}



///////////////////////////////////////////////////////////////////////////////
// SAVE WINDOW (Based On Code Contributed by Ciro Vargas Clemov)
///////////////////////////////////////////////////////////////////////////////

HANDLE ChangeBmpFormat(HBITMAP , HPALETTE );
WORD GetDIBColors (LPSTR lpDIB) ;

HB_FUNC( SAVEWINDOWBYHANDLE ) 
{
	HWND			hWnd	= ( HWND ) hb_parnl( 1 );
	HDC			hDC	= GetDC( hWnd );
	HDC			hMemDC ;
	RECT			rc ;
	HBITMAP			hBitmap ;
	HBITMAP			hOldBmp ;
	HPALETTE		hPal=0;
   TCHAR *File = (TCHAR*) HMG_parc (2);
	HANDLE			hDIB ;
	int			top	= hb_parni(3) ;
	int			left	= hb_parni(4) ;
	int			bottom	= hb_parni(5) ;
	int			right	= hb_parni(6) ;
	BITMAPFILEHEADER	bmfHdr ;     
	LPBITMAPINFOHEADER	lpBI ;       
	HANDLE			filehandle ;         
	DWORD			dwDIBSize ;
	DWORD			dwWritten ;
	DWORD			dwBmBitsSize ;

	if ( top != -1 && left != -1 && bottom != -1 && right != -1 )
	{
		rc.top = top ;
		rc.left = left ;
		rc.bottom = bottom ;
		rc.right = right ;
	}
	else
	{
		GetClientRect( hWnd, &rc );
	}

	hMemDC  = CreateCompatibleDC( hDC );
	hBitmap = CreateCompatibleBitmap( hDC, rc.right-rc.left, rc.bottom-rc.top );
	hOldBmp = ( HBITMAP ) SelectObject( hMemDC, hBitmap );
	BitBlt( hMemDC, 0, 0 , rc.right-rc.left, rc.bottom-rc.top, hDC, rc.top, rc.left, SRCCOPY );
	SelectObject( hMemDC, hOldBmp );
	hDIB = ChangeBmpFormat(hBitmap ,hPal);

	filehandle = CreateFile( File , GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL);

	lpBI = (LPBITMAPINFOHEADER)GlobalLock(hDIB);
	if (!lpBI)
	{
		CloseHandle(filehandle);
		return ;
	}

	if (lpBI->biSize != sizeof(BITMAPINFOHEADER))
	{
		GlobalUnlock(hDIB);
		CloseHandle(filehandle);
		return ;
	}

	bmfHdr.bfType = ((WORD) ('M' << 8) | 'B'); 

	dwDIBSize = *(LPDWORD)lpBI + ( GetDIBColors((LPSTR)lpBI) * sizeof(RGBTRIPLE)) ;  

	dwBmBitsSize = ((((lpBI->biWidth)*((DWORD)lpBI->biBitCount))+ 31) / 32 * 4) *  lpBI->biHeight;
	dwDIBSize += dwBmBitsSize;
	lpBI->biSizeImage = dwBmBitsSize;
                   
	bmfHdr.bfSize = dwDIBSize + sizeof(BITMAPFILEHEADER);
	bmfHdr.bfReserved1 = 0;
	bmfHdr.bfReserved2 = 0;

	bmfHdr.bfOffBits = (DWORD)sizeof(BITMAPFILEHEADER) + lpBI->biSize + ( GetDIBColors((LPSTR)lpBI) * sizeof(RGBTRIPLE)) ;

	WriteFile(filehandle, (LPSTR)&bmfHdr, sizeof(BITMAPFILEHEADER), &dwWritten, NULL);
   
	WriteFile(filehandle, (LPSTR)lpBI, dwDIBSize, &dwWritten, NULL);

	GlobalUnlock(hDIB);
	CloseHandle(filehandle);

	DeleteDC( hMemDC );
	GlobalFree (hDIB);
	ReleaseDC( hWnd, hDC );

}


HANDLE ChangeBmpFormat(HBITMAP hBitmap, HPALETTE hPal) 
{

	BITMAP              bm;         
	BITMAPINFOHEADER    bi;         
	LPBITMAPINFOHEADER  lpbi;       
	DWORD               dwLen;      
	HANDLE              hDIB, h;    
	HDC                 hDC;        
	WORD                biBits;     

	if (!hBitmap)
	{
		return 0 ;
	}

	if (!GetObject(hBitmap, sizeof(bm), (LPSTR)&bm))
	{
		return 0 ;
	}

	if ( hPal == 0 )
	{
		hPal = GetStockObject(DEFAULT_PALETTE);
	}

	biBits = bm.bmPlanes * bm.bmBitsPixel ;

	if (biBits <= 1)
	{
		biBits = 1;
	}
	else if (biBits <= 4)
	{
		biBits = 4;
	}
	else if (biBits <= 8)
	{
		biBits = 8;
	}
	else  
	{
	        biBits = 24;
	}

	bi.biSize = sizeof(BITMAPINFOHEADER);
	bi.biWidth = bm.bmWidth;
	bi.biHeight = bm.bmHeight;
	bi.biPlanes = 1;
	bi.biBitCount = biBits;
	bi.biCompression = BI_RGB;
	bi.biSizeImage = 0;
	bi.biXPelsPerMeter = 0;
	bi.biYPelsPerMeter = 0;
	bi.biClrUsed = 0;
	bi.biClrImportant = 0;

	dwLen = bi.biSize + ( GetDIBColors( (LPSTR)&bi ) * sizeof ( RGBTRIPLE ) ) ;



	hDC = GetDC(NULL);

	hPal = SelectPalette(hDC, hPal, FALSE);
	RealizePalette(hDC);

	hDIB = GlobalAlloc(GHND, dwLen);

	if (!hDIB)
	{
		SelectPalette(hDC, hPal, TRUE);
		RealizePalette(hDC);
		ReleaseDC(NULL, hDC);
		return 0;
	}

	lpbi = (LPBITMAPINFOHEADER)GlobalLock(hDIB);

	*lpbi = bi;

	GetDIBits(hDC, hBitmap, 0, (UINT)bi.biHeight, NULL, (LPBITMAPINFO)lpbi,DIB_RGB_COLORS);

	bi = *lpbi;
	GlobalUnlock(hDIB);

	if (bi.biSizeImage == 0)
	{
		bi.biSizeImage = ((((DWORD)bm.bmWidth * biBits)+ 31) / 32 * 4) * bm.bmHeight;
	}

	dwLen = bi.biSize + ( GetDIBColors( (LPSTR)&bi ) * sizeof(RGBTRIPLE)) + bi.biSizeImage;

	if ((h = GlobalReAlloc(hDIB, dwLen, 0)))
	{
		hDIB = h;
	}
	else
	{
		GlobalFree(hDIB);
		hDIB = NULL;
		SelectPalette(hDC, hPal, TRUE);
		RealizePalette(hDC);
		ReleaseDC(NULL, hDC);
		return NULL;
	}

	lpbi = (LPBITMAPINFOHEADER)GlobalLock(hDIB);

	if (GetDIBits(hDC, hBitmap, 0, (UINT)bi.biHeight, (LPSTR)lpbi + (WORD)lpbi->biSize + ( GetDIBColors ((LPSTR)lpbi) * sizeof(RGBTRIPLE)) , (LPBITMAPINFO)lpbi, DIB_RGB_COLORS) == 0)
	{
		GlobalFree(hDIB);
		hDIB = NULL;
		SelectPalette(hDC, hPal, TRUE);
		RealizePalette(hDC);
		ReleaseDC(NULL, hDC);
		return NULL;
	}

	bi = *lpbi;

	GlobalUnlock(hDIB);
	SelectPalette(hDC, hPal, TRUE);
	RealizePalette(hDC);
	ReleaseDC(NULL, hDC);

	return hDIB;

}

WORD GetDIBColors(LPSTR lpDIB)
{
    WORD wBitCount = ((LPBITMAPCOREHEADER)lpDIB)->bcBitCount;
    return wBitCount;   // ADD return value    
}

HB_FUNC ( UPDATEGRAPH )
{
	RedrawWindow ( (HWND) hb_parnl( 1 ), NULL , NULL , RDW_ERASE | RDW_INVALIDATE | RDW_ALLCHILDREN | RDW_ERASENOW | RDW_UPDATENOW ) ;
}

HB_FUNC ( _GETTABBEDCONTROLBRUSH )
{
	RECT rc;
   HBRUSH hBrush;
	SetBkMode( (HDC) hb_parnl(1) , TRANSPARENT ) ;
	GetWindowRect( (HWND) hb_parnl(2) , &rc);
	MapWindowPoints( NULL, (HWND) hb_parnl(3) , (LPPOINT)(&rc), 2);
	SetBrushOrgEx( (HDC) hb_parnl(1) , -rc.left, -rc.top, NULL);
   hBrush = (HBRUSH) hb_parnl( 4 );
   hb_retnl ((LONG) hBrush );
}


HB_FUNC( _GETTABBRUSH )
{
	HBRUSH hBrush ;
	RECT rc;
	HDC hDC ;
	HDC hDCMem  ;
	HBITMAP hBmp ;
	HBITMAP hBmp2 ;

	GetWindowRect ( (HWND) hb_parnl(1) , &rc ) ;
	hDC = GetDC( (HWND) hb_parnl(1) ) ;
	hDCMem = CreateCompatibleDC(hDC);
	hBmp = CreateCompatibleBitmap(hDC, rc.right - rc.left, rc.bottom - rc.top);
	hBmp2 = (HBITMAP)(SelectObject(hDCMem, hBmp));
	SendMessage( (HWND) hb_parnl(1) , WM_PRINTCLIENT , (WPARAM)(hDCMem) , (LPARAM)(PRF_ERASEBKGND | PRF_CLIENT | PRF_NONCLIENT ) ) ;
	hBrush = CreatePatternBrush(hBmp);

   hb_retnl ((LONG) hBrush ) ;

	SelectObject( hDCMem , hBmp2 ) ;

	DeleteObject(hBmp);
	DeleteDC(hDCMem);
	ReleaseDC( (HWND) hb_parnl(1) , hDC);

}

HB_FUNC ( _GETDDLMESSAGE )
{
	UINT g_dDLMessage = 0;
	g_dDLMessage = RegisterWindowMessage(DRAGLISTMSGSTRING);
	hb_retnl ( (LONG) g_dDLMessage );

}

HB_FUNC ( GET_DRAG_LIST_NOTIFICATION_CODE )
{
	LPARAM	lParam	= hb_parnl(1) ;
	LPDRAGLISTINFO   lpdli  = (LPDRAGLISTINFO)lParam;
	hb_retni ( lpdli->uNotification ) ;
}

HB_FUNC ( GET_DRAG_LIST_DRAGITEM )
{
	int nDragItem;
	LPARAM	lParam	= hb_parnl(1) ;
	LPDRAGLISTINFO   lpdli  = (LPDRAGLISTINFO)lParam;
	nDragItem = LBItemFromPt(lpdli->hWnd, lpdli->ptCursor, TRUE);
	hb_retni ( nDragItem ) ;
}

HB_FUNC ( DRAG_LIST_DRAWINSERT )
{
	HWND hwnd = (HWND) hb_parnl(1) ;
	LPARAM	lParam	= hb_parnl(2) ;
	int nItem = hb_parni(3);
	LPDRAGLISTINFO   lpdli  = (LPDRAGLISTINFO)lParam;
	int nItemCount ;
	nItemCount = SendMessage( (HWND) lpdli->hWnd , LB_GETCOUNT , 0, 0 ) ;
	if ( nItem < nItemCount )
	{
		DrawInsert( hwnd , lpdli->hWnd, nItem ) ;
	}
	else
	{
		DrawInsert( hwnd , lpdli->hWnd, -1 ) ;
	}
}

HB_FUNC ( DRAG_LIST_SETCURSOR_UP )
{
	SetCursor( LoadCursor( GetModuleHandle( NULL ) , _TEXT("HMG_DRAGUP") ) ) ;

}

HB_FUNC ( DRAG_LIST_SETCURSOR_DOWN )
{
	SetCursor( LoadCursor( GetModuleHandle( NULL ) , _TEXT("HMG_DRAGDOWN") ) ) ;

}

HB_FUNC ( DRAG_LIST_MOVE_ITEMS )
{
	LPARAM		lParam		= hb_parnl(1) ;
	LPDRAGLISTINFO	lpdli		= (LPDRAGLISTINFO)lParam;

	TCHAR		string[1024];
   int r;
   
	r = ListBox_GetText       (lpdli->hWnd, hb_parni(2), string);
	r = ListBox_DeleteString  (lpdli->hWnd, hb_parni(2));
	r = ListBox_InsertString  (lpdli->hWnd, hb_parni(3), string);
	r = ListBox_SetCurSel     (lpdli->hWnd, hb_parni(3));
   hb_retni (r);
}

HB_FUNC ( DRAG_LIST_GET_ITEM_COUNT )
{
	LPARAM	lParam	= hb_parnl(1) ;
	LPDRAGLISTINFO   lpdli  = (LPDRAGLISTINFO)lParam;
	int nItemCount ;
	nItemCount = SendMessage( (HWND) lpdli->hWnd , LB_GETCOUNT , 0, 0 ) ;
	hb_retni( nItemCount );
}

HB_FUNC ( GETASYNCKEYSTATE )
{
	hb_retni(GetAsyncKeyState(hb_parni(1)));
}

HB_FUNC( _HMG_CLOSEMENU )
{
	EndMenu();
}

//*************************************************************************************************
// INVALIDATERECT ( hWnd , [ {x_left, y_top, x_right, y_bottom} ] , lEraseBackground )
//*************************************************************************************************
HB_FUNC (INVALIDATERECT)
{
   RECT rect;
   PHB_ITEM pArrayRect;
   
   if ( ! HB_ISARRAY (2) )
       hb_retl (InvalidateRect((HWND) hb_parnl (1), NULL, hb_parl (3))); // Invalidate all client area
   else
   {  
      pArrayRect = hb_param (2, HB_IT_ARRAY);

      if (hb_arrayLen (pArrayRect) == 4)  
      {   rect.left   = hb_arrayGetNL (pArrayRect, 1); 
          rect.top    = hb_arrayGetNL (pArrayRect, 2);
          rect.right  = hb_arrayGetNL (pArrayRect, 3);
          rect.bottom = hb_arrayGetNL (pArrayRect, 4);
          hb_retl (InvalidateRect((HWND) hb_parnl (1), &rect, hb_parl (3))); // Invalidate specific region of client area
      }
      else
         hb_retl (FALSE);
   }
}


HB_FUNC ( GETNOTIFYHWND )
{
   hb_retnl( (LONG) (((NMHDR *) hb_parnl(1))->hwndFrom) );
}


typedef struct tagNMCHAR {
  NMHDR hdr;
  UINT  ch;
  DWORD dwItemPrev;
  DWORD dwItemNext;
} NMCHAR, *LPNMCHAR;

HB_FUNC ( GETNOTIFYCHAR )
{
   hb_retnl( (LONG) (((NMCHAR *) hb_parnl(1))->ch) );
}



//*****************************************************************************************************************//
//*   by Dr. Claudio Soto (June 2013)                                                                             *//
//*****************************************************************************************************************//


//        HMG_SendMessage (hWnd, nMsg, @wParam, @lParam) --> Return LRESULT
HB_FUNC ( HMG_SENDMESSAGE )
{  HWND hWnd   = (HWND) hb_parnl(1);
   UINT nMsg   = (UINT) hb_parnl(2);
   LONG wParam = (LONG) hb_parnl(3);
   LONG lParam = (LONG) hb_parnl(4);
   LONG lResult;

   lResult = (LONG) SendMessage (hWnd, nMsg, (WPARAM) &wParam, (LPARAM) &lParam);
   hb_retnl ((LONG) lResult);

   if (HB_ISBYREF(3))
       hb_stornl ((LONG) wParam, 3);
   if (HB_ISBYREF(4))
       hb_stornl ((LONG) lParam, 4);
}



/*
//       SendMessage_WM_SETTEXT (hWnd, cText)
HB_FUNC (SENDMESSAGE_WM_SETTEXT)
{
   SendMessage ((HWND) hb_parnl(1), WM_SETTEXT, 0, (LPARAM) HMG_parc(2));
}


//       SendMessage_WM_GETTEXT (hWnd) --> Return cText
HB_FUNC (SENDMESSAGE_WM_GETTEXT)
{  UINT nLen = 0;
   TCHAR *cText = NULL;
   nLen = (UINT) SendMessage ((HWND) hb_parnl(1), WM_GETTEXTLENGTH, 0, 0);
   if (nLen > 0)
   {  cText = (TCHAR*) hb_xgrab ((nLen+1) * sizeof(TCHAR));
      if (cText)
      {   SendMessage ((HWND) hb_parnl(1), WM_GETTEXT, nLen+1, (LPARAM) cText);
          HMG_retc( cText );
          hb_xfree( cText );
      }
      else
      HMG_retc(_TEXT(""));
   }
   else
      HMG_retc(_TEXT(""));
}
*/


//        GetParent(hWnd)
HB_FUNC ( GETPARENT )
{
   HWND hWnd = (HWND) hb_parnl (1);
   hb_retnl ((LONG)(HWND) GetParent(hWnd));
}


//        GetWindow (hWnd, uCmd)
HB_FUNC ( GETWINDOW )
{
   HWND hWnd = (HWND) hb_parnl (1);
   UINT uCmd = (UINT) hb_parnl (2);
   hb_retnl ((LONG)(HWND) GetWindow (hWnd, uCmd));
}


//        SetParent (hWndChild, hWndNewParent)
HB_FUNC ( SETPARENT )
{
   HWND hWndChild     = (HWND) hb_parnl (1);
   HWND hWndNewParent = (HWND) hb_parnl (2);
   hb_retnl ((LONG)(HWND)  SetParent (hWndChild, hWndNewParent));
}


//       SetWindowPos (hWnd, hWndInsertAfter, x, y, cx, cy, uFlags)
HB_FUNC (SETWINDOWPOS)
{
   HWND hWnd             = (HWND) hb_parnl (1);
   HWND  hWndInsertAfter = (HWND) hb_parnl (2);
   INT  x                = (INT)  hb_parnl (3);
   INT  y                = (INT)  hb_parnl (4);
   INT  cx               = (INT)  hb_parnl (5);
   INT  cy               = (INT)  hb_parnl (6);
   UINT uFlags           = (UINT) hb_parnl (7);
   hb_retl((BOOL) SetWindowPos (hWnd, hWndInsertAfter, x, y, cx, cy, uFlags));
}


//        AnimateWindow (hWnd, dwTime, dwFlags)
HB_FUNC ( ANIMATEWINDOW )
{
   HWND  hWnd    = (HWND)  hb_parnl (1);
   DWORD dwTime  = (DWORD) hb_parnl (2);
   DWORD dwFlags = (DWORD) hb_parnl (3);
   hb_retnl ((LONG) AnimateWindow ( hWnd, dwTime, dwFlags ));
}


//        FlashWindowEx (hWnd, dwFlags, uCount, dwTimeout)
HB_FUNC ( FLASHWINDOWEX )
{
   FLASHWINFO FlashWinInfo;
   FlashWinInfo.cbSize    = sizeof (FLASHWINFO);
   FlashWinInfo.hwnd      = (HWND)  hb_parnl (1);
   FlashWinInfo.dwFlags   = (DWORD) hb_parnl (2);
   FlashWinInfo.uCount    = (UINT)  hb_parnl (3);
   FlashWinInfo.dwTimeout = (DWORD) hb_parnl (4);
   hb_retl ((BOOL) FlashWindowEx (&FlashWinInfo));
}


//        SetLayeredWindowAttributes (hWnd, crKey, bAlpha, dwFlags)
HB_FUNC ( SETLAYEREDWINDOWATTRIBUTES )
{
   HWND     hWnd    = (HWND)     hb_parnl (1);
   COLORREF crKey   = (COLORREF) hb_parnl (2);
   BYTE     bAlpha  = (BYTE)     hb_parni (3);
   DWORD    dwFlags = (DWORD)    hb_parnl (4);

   if (!(GetWindowLongPtr (hWnd, GWL_EXSTYLE) & WS_EX_LAYERED))
       SetWindowLongPtr (hWnd, GWL_EXSTYLE, (GetWindowLongPtr (hWnd, GWL_EXSTYLE) | WS_EX_LAYERED));

   hb_retl ((BOOL) SetLayeredWindowAttributes (hWnd, crKey, bAlpha, dwFlags));
}


//        SetWindowTransparentStyle (hWnd)
HB_FUNC ( SETWINDOWTRANSPARENTSTYLE )
{
   HWND  hWnd  = (HWND) hb_parnl (1);
   SetWindowLongPtr (hWnd, GWL_EXSTYLE, (GetWindowLongPtr (hWnd, GWL_EXSTYLE) | WS_EX_TRANSPARENT));
}


//        CCM_SETVERSION (hWnd, nVersion)
HB_FUNC ( CCM_SETVERSION )
{
   HWND   hWnd      = (HWND)   hb_parnl (1);
   WPARAM nVersion  = (WPARAM) hb_parnl (2);
   hb_retnl ((LONG) SendMessage (hWnd, CCM_SETVERSION, nVersion, 0));
}


//        CCM_GETVERSION (hWnd)
HB_FUNC ( CCM_GETVERSION )
{
   HWND    hWnd      = (HWND)   hb_parnl (1);
   LRESULT nVersion  = (WPARAM) SendMessage (hWnd, CCM_GETVERSION, 0, 0);
   hb_retnl ((LONG) nVersion);
}


HINSTANCE hUxTheme = NULL;
typedef HRESULT ( WINAPI * func_SetWindowTheme )( HWND, LPCWSTR, LPCWSTR );

BOOL HMG_UxTheme ()
{
   if (hUxTheme == NULL)
       hUxTheme = LoadLibraryEx( _TEXT("uxtheme.dll"), NULL, 0 );
   if (hUxTheme)
      return TRUE;
   else
      return FALSE;
}


//        SetWindowTheme (hWnd, cSubAppName, cSubIdList)
HB_FUNC ( SETWINDOWTHEME )
{
   HWND    hWnd = (HWND) hb_parnl (1);
   HRESULT nRet = ( HRESULT ) NULL;

   #ifdef UNICODE
      LPCWSTR SubAppName  = (LPCWSTR) HMG_parc (2);
      LPCWSTR SubIdList   = (LPCWSTR) HMG_parc (3);
   #else
      LPCWSTR SubAppName  = (LPCWSTR) HMG_MBtoWC ( HMG_parc(2) ); // --> MultiByteToWideChar()
      LPCWSTR SubIdList   = (LPCWSTR) HMG_MBtoWC ( HMG_parc(3) ); // --> MultiByteToWideChar()
   #endif

   if( HMG_UxTheme() )
   {
      func_SetWindowTheme pSetWindowTheme = ( func_SetWindowTheme ) GetProcAddress( hUxTheme, "SetWindowTheme" );
      if( pSetWindowTheme )
         nRet = ( HRESULT ) pSetWindowTheme ( hWnd, SubAppName, SubIdList );
   }
   hb_retl( ( nRet == S_OK ) );
} 


//       GetLastActivePopup (hWnd)
HB_FUNC (GETLASTACTIVEPOPUP) 
{  HWND hWnd = (HWND) hb_parnl (1);
   hb_retnl ((LONG) GetLastActivePopup (hWnd));
}


//       WindowFromPoint (x,y)
HB_FUNC (WINDOWFROMPOINT)
{
   LONG x  = (LONG) hb_parnl (1);
   LONG y  = (LONG) hb_parnl (2);
   POINT Point;
   Point.x = x;
   Point.y = y;
   HWND hWnd = WindowFromPoint (Point);
   hb_retnl((LONG) hWnd);
}


//       ChildWindowFromPoint (hWndParent, x, y);
HB_FUNC (CHILDWINDOWFROMPOINT)
{
   HWND hWndParent = (HWND) hb_parnl (1);
   LONG x          = (LONG) hb_parnl (2);
   LONG y          = (LONG) hb_parnl (3);
   POINT Point;
   Point.x = x;
   Point.y = y;
   HWND hWndChild = ChildWindowFromPoint (hWndParent, Point);
   hb_retnl((LONG) hWndChild);
}


//       RealChildWindowFromPoint (hWndParent, x, y);
HB_FUNC (REALCHILDWINDOWFROMPOINT)
{
   HWND hWndParent = (HWND) hb_parnl (1);
   LONG x          = (LONG) hb_parnl (2);
   LONG y          = (LONG) hb_parnl (3);
   POINT Point;
   Point.x = x;
   Point.y = y;
   HWND hWndChild = RealChildWindowFromPoint (hWndParent, Point);
   hb_retnl((LONG) hWndChild);
}


//       MenuItemFromPoint (hWnd, hMenu, x, y)
HB_FUNC (MENUITEMFROMPOINT)
{  HWND  hWnd  = (HWND)  hb_parnl (1);
   HMENU hMenu = (HMENU) hb_parnl (2);
   LONG x      = (LONG)  hb_parnl (3);
   LONG y      = (LONG)  hb_parnl (4);
   POINT Point;
   Point.x = x;
   Point.y = y;
   hb_retni ((INT) MenuItemFromPoint (hWnd, hMenu, Point));
}


//       GetMenuItemRect (hWnd, hMenu, nItem, @x1, @y1, @x2, @y2)
HB_FUNC (GETMENUITEMRECT)
{  HWND  hWnd  = (HWND)  hb_parnl (1);
   HMENU hMenu = (HMENU) hb_parnl (2);
   UINT  nItem = (UINT)  hb_parni (3);
   RECT  Rect;

   hb_retl ((BOOL) GetMenuItemRect (hWnd, hMenu, nItem, &Rect));
   
   if (HB_ISBYREF(4))
       hb_stornl ((LONG) Rect.left, 4);
   if (HB_ISBYREF(5))
       hb_stornl ((LONG) Rect.top, 5);
   if (HB_ISBYREF(6))
       hb_stornl ((LONG) Rect.right, 6);
   if (HB_ISBYREF(7))
       hb_stornl ((LONG) Rect.bottom, 7);   
}


//       PtInRect (x, y, x1, y1, x2, y2)
HB_FUNC (PTINRECT)
{  RECT  Rect;
   POINT pt;
   pt.x        = (LONG) hb_parnl (1);
   pt.y        = (LONG) hb_parnl (2);
   Rect.left   = (LONG) hb_parnl (3);
   Rect.top    = (LONG) hb_parnl (4);
   Rect.right  = (LONG) hb_parnl (5);
   Rect.bottom = (LONG) hb_parnl (6);
   hb_retl ((BOOL) PtInRect (&Rect, pt));
}


//       ScreenToClient (hWnd, @x, @y)
HB_FUNC (SCREENTOCLIENT)
{
   HWND hWnd = (HWND) hb_parnl (1);
   LONG x    = (LONG) hb_parnl (2);
   LONG y    = (LONG) hb_parnl (3);
   POINT Point;
   Point.x = x;
   Point.y = y;
   hb_retl (ScreenToClient(hWnd, &Point));
   if (HB_ISBYREF(2))
       hb_stornl ((LONG) Point.x, 2);
   if (HB_ISBYREF(3))
       hb_stornl ((LONG) Point.y, 3);
}


//       ClientToScreen (hWnd, @x, @y)
HB_FUNC (CLIENTTOSCREEN)
{
   HWND hWnd = (HWND) hb_parnl (1);
   LONG x    = (LONG) hb_parnl (2);
   LONG y    = (LONG) hb_parnl (3);
   POINT Point;
   Point.x = x;
   Point.y = y;
   hb_retl (ClientToScreen(hWnd, &Point));
   if (HB_ISBYREF(2))
       hb_stornl ((LONG) Point.x, 2);
   if (HB_ISBYREF(3))
       hb_stornl ((LONG) Point.y, 3);
}


//        EnableWindowRedraw ( hWnd, lRedrawOnOff )
HB_FUNC ( ENABLEWINDOWREDRAW )
{
   HWND hWnd         = (HWND) hb_parnl (1);
   BOOL lRedrawOnOff = (BOOL) hb_parl  (2);
   
   SendMessage ( hWnd, WM_SETREDRAW, (WPARAM) lRedrawOnOff, 0 );
   
   // if (lRedrawOnOff == TRUE)   RedrawWindow (hWnd, NULL, NULL, RDW_ERASE | RDW_FRAME | RDW_INVALIDATE | RDW_ALLCHILDREN);
}



//*****************************************************************************************************************//
//*   HMG GET GLOBAL MESSAGES  (by Dr. Claudio Soto, June 2013)                                                   *//
//*****************************************************************************************************************//

HWND   _HMG_hWnd      = NULL;
UINT   _HMG_nMsg      = 0;
WPARAM _HMG_wParam    = 0;
LPARAM _HMG_lParam    = 0;
int    _HMG_nHookID   = (WH_MIN - 1);
int    _HMG_nHookCode = -1;

BOOL   _HMG_EnableProcessAllWindowMessage = TRUE;
BOOL   _HMG_EnableProcessReadKey = TRUE;
BOOL   _HMG_EnableReadKey = TRUE;

void HMG_GetWindowMessage (HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam, int nHookID, int nHookCode)
{
    static PHB_DYNS pDynSym = NULL;

   _HMG_hWnd      = hWnd;
   _HMG_nMsg      = nMsg;
   _HMG_wParam    = wParam;
   _HMG_lParam    = lParam;
   _HMG_nHookID   = nHookID;
   _HMG_nHookCode = nHookCode;

   BOOL IsKeyboardMessage = HMG_ReadKey (hWnd, nMsg, wParam, lParam);

   if (( IsKeyboardMessage == TRUE && _HMG_EnableProcessReadKey == TRUE ) || _HMG_EnableProcessAllWindowMessage == TRUE )
   {  if ( pDynSym == NULL)
           pDynSym = hb_dynsymFindName ( "EventProcess" );

      if ( pDynSym )
      {   hb_vmPushSymbol (hb_dynsymSymbol ( pDynSym ));
          hb_vmPushNil ();
          hb_vmPushLong (( LONG ) hWnd   );
          hb_vmPushLong (( LONG ) nMsg   );
          hb_vmPushLong (( LONG ) wParam );
          hb_vmPushLong (( LONG ) lParam );
          hb_vmPushLogical (( BOOL ) IsKeyboardMessage );
          hb_vmPushLogical (( BOOL ) FALSE );
          hb_vmPushLong (( LONG ) nHookID );
          hb_vmPushLong (( LONG ) nHookCode );
          hb_vmDo (8);
      }
   }
}


//       HMG_GetWindowMessageInfo (@hWnd, @nMsg, @wParam, @lParam, @nMsgTime, @idHook, @nCode)
HB_FUNC (HMG_GETWINDOWMESSAGEINFO)
{
   if (HB_ISBYREF(1))
       hb_stornl ((LONG)_HMG_hWnd, 1);
   if (HB_ISBYREF(2))
       hb_stornl ((LONG)_HMG_nMsg, 2);
   if (HB_ISBYREF(3))
       hb_stornl ((LONG)_HMG_wParam, 3);
   if (HB_ISBYREF(4))
       hb_stornl ((LONG)_HMG_lParam, 4);
   if (HB_ISBYREF(5))
       hb_stornl ((LONG)_HMG_nHookID, 5);
   if (HB_ISBYREF(6))
       hb_stornl ((LONG)_HMG_nHookCode, 6);
}


//        HMG_EnableProcessAllWindowMessage ()
HB_FUNC ( HMG_ENABLEPROCESSALLWINDOWMESSAGE )
{  
   _HMG_EnableProcessAllWindowMessage = TRUE;
}


//        HMG_DisableProcessAllWindowMessage ()
HB_FUNC ( HMG_DISABLEPROCESSALLWINDOWMESSAGE )
{
   _HMG_EnableProcessAllWindowMessage = FALSE;
}



//*****************************************************************************************************************//
//*   HMG READ KEYBOARD  (by Dr. Claudio Soto, June 2013)                                                         *//
//*****************************************************************************************************************//

WORD   _HMG_KEYDOWN_Code    = 0;
HWND   _HMG_KEYDOWN_hWnd    = NULL;
UINT   _HMG_KEYDOWN_nMsg    = 0;
WORD   _HMG_KEYDOWN_wParam  = 0;
LONG   _HMG_KEYDOWN_lParam  = 0;

WORD   _HMG_KEYUP_Code      = 0;
HWND   _HMG_KEYUP_hWnd      = NULL;
UINT   _HMG_KEYUP_nMsg      = 0;
WORD   _HMG_KEYUP_wParam    = 0;
LONG   _HMG_KEYUP_lParam    = 0;

TCHAR  _HMG_TCHAR_Char []   = {0,0};
HWND   _HMG_TCHAR_hWnd      = NULL;
UINT   _HMG_TCHAR_nMsg      = 0;
WORD   _HMG_TCHAR_wParam    = 0;
LONG   _HMG_TCHAR_lParam    = 0;


BOOL HMG_ReadKey (HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
   if (_HMG_EnableReadKey == TRUE)
   {
      if (nMsg == WM_KEYDOWN || nMsg == WM_SYSKEYDOWN)
      {   _HMG_KEYDOWN_Code   = wParam;
          _HMG_KEYDOWN_hWnd   = hWnd;
          _HMG_KEYDOWN_nMsg   = nMsg;
          _HMG_KEYDOWN_wParam = wParam;
          _HMG_KEYDOWN_lParam = lParam;
          return TRUE;
      }
      else if (nMsg == WM_KEYUP || nMsg == WM_SYSKEYUP)
      {   _HMG_KEYUP_Code   = wParam;
          _HMG_KEYUP_hWnd   = hWnd;
          _HMG_KEYUP_nMsg   = nMsg;
          _HMG_KEYUP_wParam = wParam;
          _HMG_KEYUP_lParam = lParam;
          return TRUE;
      }
      else if (nMsg == WM_CHAR || nMsg == WM_DEADCHAR || nMsg == WM_SYSCHAR || nMsg == WM_SYSDEADCHAR || nMsg == WM_MENUCHAR)
      {   _HMG_TCHAR_Char [0] = (TCHAR) wParam;
          _HMG_TCHAR_hWnd     = hWnd;
          _HMG_TCHAR_nMsg     = nMsg;
          _HMG_TCHAR_wParam   = wParam;
          _HMG_TCHAR_lParam   = lParam;
          return TRUE;
      }
   }
   return FALSE;
}

//       HMG_EnableReadKey()
HB_FUNC (HMG_ENABLEREADKEY)
{
   _HMG_EnableReadKey = TRUE;
}


//       HMG_DisableReadKey()
HB_FUNC (HMG_DISABLEREADKEY)
{
   _HMG_EnableReadKey = FALSE;
}


//       HMG_EnableProcessReadKey()
HB_FUNC (HMG_ENABLEPROCESSREADKEY)
{
   _HMG_EnableProcessReadKey = TRUE;
}


//       HMG_DisableProcessReadKey()
HB_FUNC (HMG_DISABLEPROCESSREADKEY)
{
   _HMG_EnableProcessReadKey = FALSE;
}


//        HMG_GetLastVirtualKeyDown ( [ @hWnd ], [@nMsg], [@wParam], [@lParam] ) --> nVK_Code
HB_FUNC ( HMG_GETLASTVIRTUALKEYDOWN )
{
   if (HB_ISBYREF(1))
       hb_stornl ((LONG)_HMG_KEYDOWN_hWnd, 1);
   if (HB_ISBYREF(2))
       hb_stornl ((LONG)_HMG_KEYDOWN_nMsg, 2);
   if (HB_ISBYREF(3))
       hb_stornl ((LONG)_HMG_KEYDOWN_wParam, 3);
   if (HB_ISBYREF(4))
       hb_stornl ((LONG)_HMG_KEYDOWN_lParam, 4);
   hb_retnl ((LONG)_HMG_KEYDOWN_Code);
}


//        HMG_GetLastVirtualKeyUp ( [ @hWnd ], [@nMsg], [@wParam], [@lParam] ) --> nVK_Code
HB_FUNC ( HMG_GETLASTVIRTUALKEYUP )
{
   if (HB_ISBYREF(1))
       hb_stornl ((LONG)_HMG_KEYUP_hWnd, 1);
   if (HB_ISBYREF(2))
       hb_stornl ((LONG)_HMG_KEYUP_nMsg, 2);
   if (HB_ISBYREF(3))
       hb_stornl ((LONG)_HMG_KEYUP_wParam, 3);
   if (HB_ISBYREF(4))
       hb_stornl ((LONG)_HMG_KEYUP_lParam, 4);
   hb_retnl ((LONG)_HMG_KEYUP_Code);
}


//        HMG_GetLastCharacter ( [ @hWnd ], [@nMsg], [@wParam], [@lParam] ) --> cCharacter
HB_FUNC ( HMG_GETLASTCHARACTER )
{
   if (HB_ISBYREF(1))
       hb_stornl ((LONG)_HMG_TCHAR_hWnd, 1);
   if (HB_ISBYREF(2))
       hb_stornl ((LONG)_HMG_TCHAR_nMsg, 2);
   if (HB_ISBYREF(3))
       hb_stornl ((LONG)_HMG_TCHAR_wParam, 3);
   if (HB_ISBYREF(4))
       hb_stornl ((LONG)_HMG_TCHAR_lParam, 4);
   HMG_retc (_HMG_TCHAR_Char);
}


//        HMG_GetLastVirtualKeyName ( [ lParam ] ) --> cVK_Name
HB_FUNC ( HMG_GETLASTVIRTUALKEYNAME )
{
   TCHAR cBuffer [256] = {0};
   LONG lParam;
   if (HB_ISNUM(1))
      lParam = hb_parnl(1);
   else
      lParam = _HMG_KEYDOWN_lParam;
   GetKeyNameText (lParam, cBuffer, 256);
   HMG_retc (cBuffer);
}


//        HMG_CleanLastVirtualKeyDown( [lCleanAll] )
HB_FUNC ( HMG_CLEANLASTVIRTUALKEYDOWN )
{  BOOL lCleanAll = (BOOL) hb_parl (1);
   _HMG_KEYDOWN_Code     = 0;
   if ( lCleanAll == TRUE)
   {   _HMG_KEYDOWN_hWnd     = NULL;
       _HMG_KEYDOWN_nMsg     = 0;
       _HMG_KEYDOWN_wParam   = 0;
       _HMG_KEYDOWN_lParam   = 0;
   }
}


//        HMG_CleanLastVirtualKeyUp( [lCleanAll] )
HB_FUNC ( HMG_CLEANLASTVIRTUALKEYUP )
{  BOOL lCleanAll = (BOOL) hb_parl (1);
   _HMG_KEYUP_Code     = 0;
   if ( lCleanAll == TRUE)
   {   _HMG_KEYUP_hWnd     = NULL;
       _HMG_KEYUP_nMsg     = 0;
       _HMG_KEYUP_wParam   = 0;
       _HMG_KEYUP_lParam   = 0;
   }
}


//        HMG_CleanLastCharacter( [lCleanAll] )
HB_FUNC ( HMG_CLEANLASTCHARACTER )
{  BOOL lCleanAll = (BOOL) hb_parl (1);
   _HMG_TCHAR_Char [0] = 0;
   if ( lCleanAll == TRUE)
   {   _HMG_TCHAR_hWnd    = NULL;
       _HMG_TCHAR_nMsg    = 0;
       _HMG_TCHAR_wParam  = 0;
       _HMG_TCHAR_lParam  = 0;
   }
}


//        HMG_VirtualKeyIsPressed (VK_Code)
HB_FUNC ( HMG_VIRTUALKEYISPRESSED )
{
   INT VK_Code = hb_parni(1);
   if (GetKeyState(VK_Code) < 0)
     hb_retl (TRUE);
   else
     hb_retl (FALSE); 
}


//        GetKeyState (VK_Code)   --> return nKeyState
HB_FUNC ( GETKEYSTATE )
{
   INT VK_Code = hb_parni(1);
   hb_retni ((INT) GetKeyState (VK_Code));
}


//        HMG_SendCharacter ( [ hWnd ], cText)
HB_FUNC ( HMG_SENDCHARACTER )
{  INT i;
   HWND  hWnd;
   if (HB_ISNUM(1))
       hWnd = (HWND) hb_parnl (1);
   else
       hWnd = GetFocus ();
   if ( hWnd )
   {   TCHAR *cText = (TCHAR*) HMG_parc (2);
       for (i=0; i < lstrlen(cText); i++)
            PostMessage (hWnd, WM_CHAR, (WPARAM) cText[i], (LPARAM) 0);
   }
}


//*****************************************************************************************************************//
//*   HMG  HOOKS  (by Dr. Claudio Soto, July 2013)                                                                *//
//*****************************************************************************************************************//

HHOOK hHook_CallWndProc = NULL;
HHOOK hHook_MessageProc = NULL;


//   HMG_EventReturn (&ReturnValue) --> Return TRUE if function return a Number, FALSE if return NIL or other value
BOOL HMG_EventReturn (long *ReturnValue)
{
   if (hb_parinfo ( -1 ) & HB_IT_NUMERIC)
   {  *ReturnValue = (long) hb_parnl ( -1 );
      return TRUE;
   }
   else
   {  *ReturnValue = 0;
      return FALSE;
   }
}


// The system calls this function before calling the window procedure to process a message sent to the thread.
LRESULT CALLBACK CallWndProc (int nCode, WPARAM wParam, LPARAM lParam)
{  LONG ReturnValue;
   CWPSTRUCT *Msg;
   if (nCode >= 0  &&  wParam != 0)
   {   Msg = (CWPSTRUCT *) lParam;
       HMG_GetWindowMessage (Msg->hwnd, Msg->message, Msg->wParam, Msg->lParam, WH_CALLWNDPROC, nCode);
       if (HMG_EventReturn (&ReturnValue) == TRUE)
           return 0;   // ReturnValue;   // If the hook procedure does not call CallNextHookEx, the return value should be zero
   }
   return CallNextHookEx(hHook_CallWndProc, nCode, wParam, lParam);
}


// The system calls after an input event occurs in a dialog box, message box, menu, or scroll bar, 
// but before the message generated by the input event is processed
LRESULT CALLBACK MessageProc (int nCode, WPARAM wParam, LPARAM lParam)
{  LONG ReturnValue;
   MSG *Msg;
   if (nCode >= 0)
   {   Msg = (MSG *) lParam;
       HMG_GetWindowMessage (Msg->hwnd, Msg->message, Msg->wParam, Msg->lParam, WH_MSGFILTER, nCode);
       if (HMG_EventReturn (&ReturnValue) == TRUE)
           return (ReturnValue != 0 ? ReturnValue : 1);   // If the hook procedure processed the message, it may return a nonzero value
   }
   return CallNextHookEx (hHook_MessageProc, nCode, wParam, lParam);
}



HB_FUNC (HMG_HOOK_INSTALL)
{
   if (hHook_CallWndProc == NULL && hHook_MessageProc == NULL)
   {   hHook_CallWndProc = SetWindowsHookEx (WH_CALLWNDPROC, CallWndProc, (HINSTANCE) NULL, GetCurrentThreadId());
       hHook_MessageProc = SetWindowsHookEx (WH_MSGFILTER,   MessageProc, (HINSTANCE) NULL, GetCurrentThreadId());
       
       if (hHook_CallWndProc && hHook_MessageProc)
           hb_retl(TRUE);
       else
           hb_retl(FALSE);
   }
   else
      hb_retl(FALSE);
}


HB_FUNC (HMG_HOOK_UNINSTALL)
{
   if (hHook_CallWndProc != NULL)
       UnhookWindowsHookEx (hHook_CallWndProc);

   if (hHook_MessageProc != NULL)
       UnhookWindowsHookEx (hHook_MessageProc);
}

